﻿#NoEnv
#Warn
SendMode Input
#SingleInstance force
#Include RichEdit OleCallback.ahk

RE_Dll := DllCall("LoadLibrary", "Str", "Msftedit.dll", "Ptr")
Gui, +hwndhGui
Gui +LastFound +Resize
Gui, Margin, 10, 10
Gui, Font, s10, Arial
;Gui, Add,Edit, h200 w200
Gui, Add, Custom, ClassRICHEDIT50W w1025 h700 vRE hwndHRE +VScroll +0x1004 ; ES_MULTILINE | ES_WANTRETURN
RE_SetOleCallback(HRE) ; Thanks to DigiDon and just me. This uses a function from RichEdit OleCallback.ahk
GetTomDoc(HRE)
OnMessage(0x204, "RightClick") ; WM_RIGHTBUTTONDOWN
Gui, Show, , RichEdit


return

RightClick(wParam, lParam)
{
    X := lParam & 0xFFFF
    Y := lParam >> 16
	Gosub, MakeMenu
	return
}


^!m::
GuiContextMenu:
gosub, MakeMenu
;MsgBox Context Menu: %A_ThisLabel%
return


Escape::
GuiClose:
ExitApp

MakeMenu:
Menu, RTE_Menu, Add, &Copy, Copy  ; Simple context menu
Menu, RTE_Menu, Add, &Paste, Paste  ; 
Menu, RTE_Menu, Add, Cu&t, Cut  ; 
Menu, RTE_Menu, Add, Select &All, All ; 
Menu, RTE_Menu, Add, &Undo, Undo ; 

Menu, RTE_Menu, Show
return

Copy:
Send, ^c
return

Paste:
Send, ^v
return

Cut:
Send, ^x
return

All:
Send, ^a
return

Undo:
Send, ^z
return

return


GetTomDoc(HRE) {
   ; Get the document object of the specified RichEdit control
   IRichEditOle := "" ;Added to stop warning messages
   Static IID_ITextDocument := "{8CC497C0-A1DF-11CE-8098-00AA0047BE5D}"
   DocObj := 0
   If DllCall("SendMessage", "Ptr", HRE, "UInt", 0x043C, "Ptr", 0, "PtrP", IRichEditOle, "UInt") { ; EM_GETOLEINTERFACE
      DocObj := ComObject(9, ComObjQuery(IRichEditOle, IID_ITextDocument), 1) ; ITextDocument
      ObjRelease(IRichEditOle)
   }
   Return DocObj
}